package com.company.sample.core;

import com.haulmont.bpm.entity.ProcActor;
import com.haulmont.cuba.core.global.DataManager;
import com.haulmont.cuba.core.global.LoadContext;
import com.haulmont.cuba.core.global.View;
import org.springframework.stereotype.Component;

import javax.inject.Inject;
import java.util.List;
import java.util.UUID;

@Component("demo_ProcessUtils")
public class BpmProcessUtils {

    @Inject
    protected DataManager dataManager;

    public boolean roleExists(String roleCode, UUID bpmProcInstanceId) {
        LoadContext<ProcActor> ctx = LoadContext.create(ProcActor.class).setView(View.MINIMAL);
        ctx.setQueryString("select pa from bpm$ProcActor pa where pa.procRole.code = :roleCode and " +
                "pa.procInstance.id = :bpmProcInstanceId")
                .setParameter("roleCode", roleCode)
                .setParameter("bpmProcInstanceId", bpmProcInstanceId);
        List<ProcActor> procActors = dataManager.loadList(ctx);
        return !procActors.isEmpty();
    }
}